Attribute VB_Name = "Functions"
Global Const pi = 3.14159265358979
Global Const pi2 = 2 * pi

' This is the declaration required if you want to change the contents of
' other variables or move memory from one place to another. Note that all adresses are passed ByValue.
' The adresses are passed as "Any" because Varptr returnes an unsigned long - this means that adresses
' can be negative if a normal (signed) long integer is assumed
Declare Sub MemoryBmove Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest As Any, ByVal hpvSource As Any, ByVal cbCopy As Long)



Public Function filetitle(ByVal fullname$) As String

    Dim pos As Integer
    Dim i As Integer
    Dim l As Integer
    Dim t$
    l = Len(fullname$)
    
    For i = l To 1 Step -1
    
        t$ = Mid$(fullname$, i, 1)
        If t$ = "\" Then
            Exit For
        End If
    
    Next i
    
    If i > 0 Then
        t$ = Right$(fullname$, l - i)
    Else
        t$ = fullname$
    End If
    
    If Len(t$) = 2 Then ' checking if fullname is just a drive
        If Right$(t$, 1) = ":" Then
            t$ = ""
        End If
    End If
    
    tt$ = Right$(t$, 1)
    If tt$ = "*" Or tt$ = "." Then ' why that?????
        't$ = ""
    End If
    
    tt$ = Left$(t$, 1)
    If tt$ = "*" Or tt$ = "." Then
        t$ = ""
    End If
    
    filetitle = t$

End Function


Function p1()

    Dim tstep As Double
    Dim w As Double
    Dim nn As Double
    Dim tf As Double
    Dim i As Integer
    Dim j As Integer
    Dim Sps As Long
    Dim freq1 As Double
    Dim y As Single
    Dim Y1 As Single
    Dim n As Long
    Dim nstep As Long
    Dim Tau As Double
    Tau = 0.7
    freq1 = 800
    Sps = 44100

    If 1 = 1 Then

        tstep = 1 / Sps   ' Dauer fuer 1 Sample - wird zurueckgegeben
        'freq1 = 1001
        w = 2 * pi * freq1
        tf = 1 / freq1    ' Dauer einer Schwingung
        nn = tf / tstep
        nn = Int(nn)
       
        For n = 1 To (Tau / tstep) Step nn
            y = Sin(n * w * tstep)
            j = 0
            'MsgBox n & " " & " " & j & " " & y
'            If n = 49 Then
'                Stop
'            End If
            For j = 0 To nn
                y = Sin((n + j) * w * tstep)
                'MsgBox n & " " & " " & j & " " & y
                If Abs(y) < 0.005 Then
                    
                    Y2 = Cos((n + j) * w * tstep)
                    If Y2 > 0.99 Then
                        nstep = n + j
                        'MsgBox "Bingo " & " " & nstep
                        GoTo done
                    End If
                Else
    '                If y > 0 Then
    '                    Exit For
    '                End If
                    
                End If
            Next j
        Next n
        
done:
        If nstep = 0 Then
        MsgBox nstep
        End If
    Else
        
        tstep = 1 / Sps   ' Dauer fuer 1 Sample - wird zurueckgegeben
        tf = 1 / freq1    ' Dauer einer Schwingung
        n = tf / tstep
        w = 2 * pi * freq1

        If TauMin <> 0 Then
            Tau = 0.5
        End If
        nSteps = Tau / tstep
            
        t = 0
        For i = 1 To nSteps
            t = t + tstep
            y = Sin(t * w)
            If i = 792 Then
               ' Stop
            End If
            'If t >= TauMin Then
                If Abs(y) < 0.005 Then
                  If Cos(t * w) > 0.99 Then
                        Exit For
                  End If
                End If
            'End If
        Next i
        
        If i < nSteps Then
            nSteps = i - 0
        Else
            'MsgBox "oh"
            nSteps = i
        End If
        'MsgBox nsteps
    End If
    


End Function


Function String4_to_Long(ByVal Source$) As Long

    Dim result As Long
    Dim a As Byte
    
    For i = 1 To 4
        a = Asc(Mid$(Source$, i, 1))
        POKE VarPtr(result) + i - 1, a
    Next i
    
    String4_to_Long = result
    
End Function

Sub POKE(ByVal dest As Long, ByVal pokeval As Byte)

    Dim addr As Long
    addr = VarPtr(pokeval)
    Call MemoryBmove(dest, ByVal addr, 1)
  
End Sub

Sub BMOVE(ByVal adrSource As Long, ByVal adrDest As Long, ByVal nBytes As Long)

    ' This sub is just used for clarity I.e. Binary Move source to destination
    ' and to get the same syntax as in older BASIC dialects.
    ' Also it also makes sure that adrSouce is alway passed by value and blocks
    ' the fatal error of passing negative numbers.
    
    If nBytes <= 0 Then
        If nBytes < 0 Then
            MsgBox "Attempt to use RTLMoveMemory with negative number of bytes - not performed!"
        End If
        Exit Sub ' negative values will cause a crash
    End If
    
    If adrDest = 0 Then
        MsgBox "Attempt to use RTLMoveMemory write to adress zero - not performed!"
        Exit Sub
    End If
    
    Call MemoryBmove(adrDest, ByVal adrSource, nBytes)

End Sub
Function DirExist(dirname$) As Long

    On Error GoTo err1
    
    Dim chk As Integer
    Dim Subname$
    Dim olddir$
    
    Subname$ = "Direxist"

    olddir$ = CurDir("")
    ChDir dirname$
     
    'if its not there an error occurs
    chk = -1
    
    
err_resume:

    ChDir olddir$
    DirExist = chk
    
exi:

Exit Function

'**************** normal end of function *******************'

err1:

    Select Case Err

    Case 53, 52
        chk = Err
        Resume err_resume
        
    Case 76
        chk = 0
        Resume err_resume
        
    Case Else
    
        MsgBox Str$(Err) + " " + Error$, 16, "Function " + Subname$
        'Resume
        Resume exi:

    End Select

err2:

End Function

Function FileExist(Filename$) As Integer

    On Error GoTo err1
    
    Dim chk As Integer
    Dim Subname$
    Dim ll As Long
    Subname$ = "Fileexist"

    ll = FileLen(Filename$)
    If ll >= 0 Then
        chk = -1
    Else
        chk = 0
    End If
    
err_resume:
    FileExist = chk
exi:

    Exit Function

'**************** normal end of function **********'

err1:

    Select Case Err

    Case 53, 52
        chk = 0
        Resume err_resume
        
    Case 76
        chk = Err
        Resume err_resume
        
    Case Else
    
        MsgBox Str$(Err) + " " + Error$, 16, "Function " + Subname$
        'Resume
        Resume exi:

    End Select

err2:

End Function


Function appath() As String

    Dim path$

    path$ = App.path
    
    If Right$(path$, 1) = "\" Then
        path$ = Left$(path$, Len(path$) - 1)
    End If
    
    appath = path$
    
End Function







